Scriptname vibMUTEXSCT extends Quest Hidden

Bool[] locks
String[] lockNames
Int lockCount

Event OnInit()
	locks = New Bool[128]
	lockNames = New String[128]
	lockCount = 0
EndEvent

Bool Function isLocked(String asLockName)
	Int index = lockNames.Find(asLockName)
	If (index >= 0)
		Return locks[index]
	EndIf
	Return False
EndFunction

Bool Function lock(String asLockName, Float asDeadlockSeconds = 0.0)
	Int index = lockNames.Find(asLockName)
	If (index < 0)
		index = lockCount
		locks[index] = False
		lockNames[index] = asLockName
		lockCount += 1
	EndIf

	Int iterations = 0
	Int deadlock = 384
	If (asDeadlockSeconds > 0)
		deadlock += (5 * asDeadlockSeconds) As Int
	Else
		deadlock += 384
	EndIf

	Bool wasLocked = locks[index]
	While (locks[index] && iterations < deadlock)
		iterations += 1
		; If (iterations % 50 == 0)
			; Debug.Notification("lock \"" + asLockName + "\" is locked (" + iterations + ")")
		; EndIf

		If (Utility.IsInMenuMode())
			Utility.WaitMenuMode(0.2)
		Else
			Utility.Wait(0.2)
		EndIf
	EndWhile

	locks[index] = True
	return wasLocked
EndFunction

Function unlock(String asLockName)
	Int index = lockNames.Find(asLockName)
	If (index >= 0)
		locks[index] = False
	EndIf
EndFunction

Function unlockAll()
	Int index = 0
	While (index < lockCount)
		locks[index] = False
		index += 1
	EndWhile
EndFunction

Function listRunningLocks()
	Int index = 0
	While (index < lockCount)
		If (locks[index])
			Debug.Notification(lockNames[index] + " is locked")
			index += 1
		EndIf
	EndWhile
EndFunction
