Scriptname vibMainSCT extends Quest Hidden

vibMUTEXSCT Property mutex Auto

Actor Property PlayerREF Auto
Quest Property vibSleepQST Auto
Quest Property vibBedAliasFlipQST Auto
Quest Property vibBedAliasFlopQST Auto
Faction Property PlayerBedOwnership Auto
vibActorClothingSCT Property PlayerClothing Auto
FormList Property vibBedsLST Auto
FormList Property vibClothesLST Auto

Float Property PlayerScale Auto Hidden
Float Property UpdateInterval Auto Hidden
Float Property UpdateIntervalDefault Auto Hidden

Float Property SnoozeDuration Auto Hidden
Float Property SnoozeDurationDefault Auto Hidden
Float Property SnoozeDurationMin Auto Hidden
Float Property SnoozeDurationMax Auto Hidden

String Property UndressMethod Auto Hidden
String Property UndressMethodDefault Auto Hidden
String[] Property UndressMethodValueSet Auto Hidden

GlobalVariable Property vibSpouseEnabled Auto
Bool Property SpouseEnabled Auto Hidden
Bool Property SpouseEnabledDefault Auto Hidden

GlobalVariable Property vibFollowersEnabled Auto
Bool Property FollowersEnabled Auto Hidden
Bool Property FollowersEnabledDefault Auto Hidden

Bool Property ResetControls Auto Hidden
Bool Property Uninstall Auto Hidden

ObjectReference Property BedAliasBuffer Auto Hidden

Int EquippedItemsCount
Int[] EquippedItemSlots
Form[] EquippedItems

Int Property Revision Auto Hidden
Int Property NewRevision Hidden
	Int Function Get()
		Return 6
	EndFunction
EndProperty

Function CheckRevision()
	If (Revision < NewRevision)
		OnRevisionUpdate(Revision, NewRevision)
		Revision = NewRevision
	EndIf
EndFunction

Bool[] Property DLCisLoaded Auto Hidden
Int[] Property DLCknownFormID Auto Hidden
String[] Property DLCfileNames Auto Hidden

Function CheckFiles()
	Debug.Trace("|---------------------------------------------------------------------------------------------------------------------|")
	Debug.Trace("|               IMMERSIVE BEDS is now performing compatibility check. Papyrs warning should be ignored.               |")
	Debug.Trace("|---------------------------------------------------------------------------------------------------------------------|")

	Int index = 0
	While (index < DLCisLoaded.Length)
		If (DLCisLoaded[index])
			DLCisLoaded[index] = Game.GetFormFromFile(DLCknownFormID[index], DLCfileNames[index])
		Else
			DLCisLoaded[index] = Game.GetFormFromFile(DLCknownFormID[index], DLCfileNames[index])
			If (DLCisLoaded[index])
				If (DLCfileNames[index] == "HearthFires.esm")
					If (Game.GetFormFromFile(0x02008E40, "Dawnguard.esm"))
						AddBedFromFile(0x02000801, DLCfileNames[index]) ; BYOHVampireCoffinVert01
					Else
						DLCisLoaded[index] = False
					EndIf

				ElseIf (DLCfileNames[index] == "Dawnguard.esm")
					AddBedFromFile(0x02008E40, DLCfileNames[index]) ; DLC1Coffin01
					AddBedFromFile(0x0200B64E, DLCfileNames[index]) ; VampireCoffinVertical
					AddBedFromFile(0x0200C651, DLCfileNames[index]) ; DLC1BedrollGroundF
					AddBedFromFile(0x0200CCF0, DLCfileNames[index]) ; DLC1VampireCoffinHoriz01
					AddBedFromFile(0x0200CCF1, DLCfileNames[index]) ; DLC1VampireCoffinHoriz02
					AddBedFromFile(0x0200CCF2, DLCfileNames[index]) ; DLC1VampireCoffinVert01
					AddBedFromFile(0x0200CCF3, DLCfileNames[index]) ; DLC1VampireCoffinVert02
					AddBedFromFile(0x0201A68B, DLCfileNames[index]) ; DLC1Coffin01testjoeltestdeletemetest

				ElseIf (DLCfileNames[index] == "Dragonborn.esm")
					AddBedFromFile(0x02018617, DLCfileNames[index]) ; BedrollHay01LDirtSnowPath01F
					AddBedFromFile(0x02018618, DLCfileNames[index]) ; BedrollHay01LDirtSnowPath01R
					AddBedFromFile(0x0201EE28, DLCfileNames[index]) ; BedrollHay01LDirtSnowPath
					AddBedFromFile(0x02021749, DLCfileNames[index]) ; DLC2DarkElfBed01
					AddBedFromFile(0x02025E51, DLCfileNames[index]) ; BedrollHay01IceL
					AddBedFromFile(0x02025E52, DLCfileNames[index]) ; BedrollHay01IceR
					AddBedFromFile(0x02028A68, DLCfileNames[index]) ; BedrollHay01R_Ash
					AddBedFromFile(0x02028AA9, DLCfileNames[index]) ; BedrollHay01L_Ash
					AddBedFromFile(0x0202C0B2, DLCfileNames[index]) ; BedrollHay01LDirtPath01L
					AddBedFromFile(0x0202C0B3, DLCfileNames[index]) ; BedrollHay01LDirtPath01F
					AddBedFromFile(0x0202C0B4, DLCfileNames[index]) ; BedrollHay01LDirtPath01R
					AddBedFromFile(0x02032802, DLCfileNames[index]) ; DLC2DarkElfBedDouble01
					AddBedFromFile(0x02035037, DLCfileNames[index]) ; DLC2DarkElfBed01R
					AddBedFromFile(0x02035038, DLCfileNames[index]) ; DLC2DarkElfBed01L
					AddBedFromFile(0x02036796, DLCfileNames[index]) ; DLC2DarkElfBedDouble01R
					AddBedFromFile(0x02036797, DLCfileNames[index]) ; DLC2DarkElfBedDouble01L
					AddBedFromFile(0x0203D131, DLCfileNames[index]) ; BedrollHay01GlacierL
					AddBedFromFile(0x0203D132, DLCfileNames[index]) ; BedrollHay01GlacierR

				EndIf
			EndIf
		EndIf

		index += 1
	EndWhile

	Debug.Trace("|---------------------------------------------------------------------------------------------------------------------|")
	Debug.Trace("|                                    IMMERSIVE BEDS finished compatibility check.                                     |")
	Debug.Trace("|---------------------------------------------------------------------------------------------------------------------|")
EndFunction

Function AddBedFromFile(Int aiBedID, String asFileName)
	Form BedForm = Game.GetFormFromFile(aiBedID, asFileName)
	If (!vibBedsLST.HasForm(BedForm))
		; Debug.Notification("Adding " + BedForm.GetName())
		vibBedsLST.AddForm(BedForm)
	EndIf
EndFunction

Event OnRevisionUpdate(Int aiRevision, Int aiNewRevision)
	If (aiRevision < 1)
		; locks = New Bool[128]
		; lockNames = New String[128]
		; lockCount = 0

		EquippedItemsCount = 0
		EquippedItemSlots = New Int[128]
		EquippedItems = New Form[128]

		UpdateIntervalDefault = 0.5
		UpdateInterval = UpdateIntervalDefault

		SnoozeDurationDefault = 3.0
		SnoozeDuration = SnoozeDurationDefault
		SnoozeDurationMin = 0
		SnoozeDurationMax = 30

		UndressMethodValueSet = New String[4]
		UndressMethodValueSet[0] = "Disabled"
		UndressMethodValueSet[1] = "Comfortable"
		UndressMethodValueSet[2] = "Clothes"
		UndressMethodValueSet[3] = "Nude"

		UndressMethodDefault = "Disabled"
		UndressMethod = UndressMethodDefault

		ResetControls = False
	EndIf

	If (aiRevision < 2)
		RegisterForSingleUpdate(0.1)
		; RegisterForMenu("Loading Menu")
		; RegisterForModEvent("SKICP_modSelected", "OnModSelect")
	EndIf

	If (aiRevision < 5)
		UnregisterForAllMenus()
		UnregisterForAllModEvents()

		DLCisLoaded = New Bool[3]
		DLCknownFormID = New Int[3]
		DLCknownFormID[0] = 0x02000801
		DLCknownFormID[1] = 0x02008E40
		DLCknownFormID[2] = 0x02018617

		DLCfileNames = New String[3]
		DLCfileNames[0] = "HearthFires.esm"
		DLCfileNames[1] = "Dawnguard.esm"
		DLCfileNames[2] = "Dragonborn.esm"
		
		SpouseEnabledDefault = False
		SpouseEnabled = SpouseEnabledDefault
		vibSpouseEnabled.SetValue(SpouseEnabledDefault As Int)
	EndIf

	If (aiRevision < 6)
		Int CurrentMethodIndex = UndressMethodValueSet.Find(UndressMethod)
		UndressMethodValueSet = New String[4]
		UndressMethodValueSet[0] = "SLP_DISABLED"
		UndressMethodValueSet[1] = "SLP_COMFORTABLE"
		UndressMethodValueSet[2] = "SLP_CLOTHES"
		UndressMethodValueSet[3] = "SLP_NUDE"

		UndressMethodDefault = UndressMethodValueSet[0]
		UndressMethod = UndressMethodValueSet[CurrentMethodIndex]

		FollowersEnabledDefault = False
		FollowersEnabled = FollowersEnabledDefault
		vibFollowersEnabled.SetValue(FollowersEnabledDefault As Int)
	EndIf

EndEvent

Event OnInit()
	CheckRevision()
EndEvent

Event OnPlayerLoadGame()
	CheckRevision()
	CheckFiles()
EndEvent

Event OnUpdate()
	; Debug.Notification("onUpdate")
	If (vibBedAliasFlipQST.IsRunning())
		mutex.lock("BedAliasFlip", SnoozeDuration)
		; Debug.Notification("Flop")
		vibBedAliasFlopQST.Start()
		Utility.Wait(0.2)
		vibBedAliasFlipQST.Stop()
		mutex.unlock("BedAliasFlip")
	Else
		mutex.lock("BedAliasFlop", SnoozeDuration)
		; Debug.Notification("Flip")
		vibBedAliasFlipQST.Start()
		Utility.Wait(0.2)
		vibBedAliasFlopQST.Stop()
		mutex.unlock("BedAliasFlop")
	EndIf


	If (!Uninstall)
		RegisterForSingleUpdate(UpdateInterval)
	Else
		Debug.Notification(" Immersive Beds .")
	EndIf
EndEvent

Function Undress()
	mutex.lock("dress", SnoozeDuration)
	If (UndressMethod != "SLP_DISABLED")
		EquippedItemsCount = 0
		EquippedItemSlots = New Int[128]
		EquippedItems = New Form[128]

		TryUnequip(PlayerREF.GetEquippedWeapon())
		TryUnequip(PlayerREF.GetEquippedWeapon(), 1)
		TryUnequip(PlayerREF.GetEquippedWeapon(True), 2)

		TryUnequip(PlayerREF.GetEquippedShield())
		TryUnequip(PlayerClothing.EquippedAmmo)
		TryUnequip(PlayerClothing.EquippedLight)

		If (UndressMethod == "SLP_NUDE")
			Int index = 30
			While (index <= 61)
				TryUnequip(PlayerClothing.EquppedBodySlot(index))
				index += 1
			EndWhile
			PlayerREF.UnequipAll()

		Else
			TryUnequip(PlayerClothing.EquppedBodySlot(30))
			TryUnequip(PlayerClothing.EquppedBodySlot(31))
			TryUnequip(PlayerClothing.EquppedBodySlot(33))
			TryUnequip(PlayerClothing.EquppedBodySlot(37))
			TryUnequip(PlayerClothing.EquppedBodySlot(46))
			TryUnequip(PlayerClothing.EquppedBodySlot(47))
			TryUnequip(PlayerClothing.EquppedBodySlot(55))

			If (UndressMethod == "SLP_CLOTHES" && PlayerREF.GetItemCount(vibClothesLST) > 0)
				Int ClothesAvailableCount = 0
				Form[] ClothesAvailable = New Form[128]

				Int index = 0
				While (index < vibClothesLST.GetSize() && ClothesAvailableCount < PlayerREF.GetItemCount(vibClothesLST))
					If (PlayerREF.GetItemCount(vibClothesLST.GetAt(index)) > 0)
						ClothesAvailable[ClothesAvailableCount] = vibClothesLST.GetAt(index)
						ClothesAvailableCount += 1
					EndIf
					index += 1
				EndWhile

				TryUnequip(PlayerClothing.EquppedBodySlot(32))
				Utility.Wait(0.2)
				TryEquip(ClothesAvailable[Utility.RandomInt(0, ClothesAvailableCount - 1)])
			EndIf

		EndIf
	EndIf
	mutex.unlock("dress")
EndFunction

Function Dressup()
	mutex.lock("dress", SnoozeDuration)
	Utility.Wait(0.5)

	Int index = EquippedItemsCount
	While (index >= 0)
		TryEquip(EquippedItems[index], EquippedItemSlots[index])
		index -= 1
	EndWhile

	EquippedItemsCount = 0
	EquippedItems = New Form[128]
	mutex.unlock("dress")
EndFunction

Function TryUnequip(Form akItem, Int aiItemSlot = 0)
	If (akItem)
		PlayerREF.UnequipItem(akItem, False, True)
		EquippedItems[EquippedItemsCount] = akItem
		EquippedItemSlots[EquippedItemsCount] = aiItemSlot
		EquippedItemsCount += 1
		Utility.Wait(0.2)
	EndIf
EndFunction

Function TryEquip(Form akItem, Int aiItemSlot = 0)
	If (akItem)
		PlayerREF.EquipItemEx(akItem, aiItemSlot, False, True)
		Utility.Wait(0.2)
	EndIf
EndFunction

Function RefreshFace()
	Utility.SetINIBool("bUseFaceGenPreprocessedHeads:General", False)
	PlayerREF.QueueNiNodeUpdate()
	Utility.SetINIBool("bUseFaceGenPreprocessedHeads:General", True)
EndFunction