Scriptname vibSpouseAliasSCT extends ReferenceAlias Hidden

vibMUTEXSCT Property mutex Auto

vibMainSCT Property vibMainQST Auto
FormList Property vibClothesLST Auto
Armor Property SkinNaked Auto
Package Property vibSleepSpousePKG Auto

Event OnInit()
	GoToState("")
	If GetActorReference()
		GoToState("GoingToBed")
		RegisterForSingleUpdate(0.5)
	EndIf
EndEvent

State GoingToBed

	Event OnUpdate()
		If GetActorReference()
			; Int SleepState = GetActorReference().GetSleepState()
			; If (SleepState > 0 && SleepState < 4)
			If (GetActorReference().GetCurrentPackage() == vibSleepSpousePKG)
				GoToState("Sleeping")
				mutex.lock("SpouseAlias")
				RegisterForAnimationEvent(GetActorReference(), "IdleFurnitureExit")
				Undress()
			EndIf
			RegisterForSingleUpdate(vibMainQST.UpdateInterval)
		EndIf
	EndEvent

EndState

State Sleeping

	Event OnAnimationEvent(ObjectReference akSource, string asEventName)
		GoToState("")
		If GetActorReference()
			UnregisterForAnimationEvent(GetActorReference(), "IdleFurnitureExit")
			Dressup()
		EndIf
		mutex.unlock("SpouseAlias")
	EndEvent

EndState


Function Undress()
	mutex.lock("SpouseDress", 1)
	If (GetActorReference() && vibMainQST.UndressMethod != "Disabled")
		TryUnequip(GetActorReference().GetEquippedWeapon())
		TryUnequip(GetActorReference().GetEquippedWeapon())
		TryUnequip(GetActorReference().GetEquippedWeapon(True))
		TryUnequip(GetActorReference().GetEquippedShield())

		If (vibMainQST.UndressMethod == "Nude")
			GetActorReference().UnequipAll()
		Else
			TryUnequipItemSlot(30)
			TryUnequipItemSlot(31)
			TryUnequipItemSlot(33)
			TryUnequipItemSlot(37)
			TryUnequipItemSlot(46)
			TryUnequipItemSlot(47)
			TryUnequipItemSlot(55)

			If ((vibMainQST.UndressMethod == "Clothes") &&\
				(GetActorReference().GetItemCount(vibClothesLST) > 0))
				Int ClothesAvailableCount = 0
				Form[] ClothesAvailable = New Form[128]

				Int index = 0
				While ((index < vibClothesLST.GetSize()) &&\
					GetActorReference() &&\
					(GetActorReference().GetItemCount(vibClothesLST) > ClothesAvailableCount))
					If (GetActorReference().GetItemCount(vibClothesLST.GetAt(index)) > 0)
						ClothesAvailable[ClothesAvailableCount] = vibClothesLST.GetAt(index)
						ClothesAvailableCount += 1
					EndIf
					index += 1
				EndWhile

				TryUnequipItemSlot(32)
				Utility.Wait(0.2)
				TryEquip(ClothesAvailable[Utility.RandomInt(0, ClothesAvailableCount - 1)])
			EndIf
		EndIf
	EndIf
	mutex.unlock("SpouseDress")
EndFunction

Function Dressup()
	mutex.lock("SpouseDress", 1)
	If (GetActorReference() && vibMainQST.UndressMethod != "Disabled")
		Actor SpouseActor = GetActorReference()
		Utility.Wait(0.2)
		SpouseActor.AddItem(SkinNaked, 1, True)
		Utility.Wait(0.3)
		SpouseActor.RemoveItem(SkinNaked, 1, True)
	EndIf
	mutex.unlock("SpouseDress")
EndFunction

Function TryEquip(Form akItem)
	If (GetActorReference() && akItem)
		GetActorReference().EquipItem(akItem, False, True)
		Utility.Wait(0.2)
	EndIf
EndFunction

Function TryUnequip(Form akItem)
	If (GetActorReference() && akItem)
		GetActorReference().UnequipItem(akItem, False, True)
		Utility.Wait(0.2)
	EndIf
EndFunction

Function TryUnequipItemSlot(Int aiSlot)
	If GetActorReference()
		GetActorReference().UnequipItemSlot(aiSlot)
		Utility.Wait(0.2)
	EndIf
EndFunction